#define BUTTON1_PIN 2
#define BUTTON2_PIN 7
#define BUTTON3_PIN 4

#define SLIDER1_PIN 2
#define SLIDER2_PIN 1
#define SLIDER3_PIN 0

#define LIGHT_SENSOR_PIN 3
#define TEMP_SENSOR_PIN 4
#define KNOCK_SENSOR_PIN 8

#define LED1_PIN 6
#define LED2_PIN 5

#define BUZZER_PIN 3

#define SLIDER1_LED_PIN 11
#define SLIDER2_LED_PIN 10
#define SLIDER3_LED_PIN 9

#define LATCH_PIN 8
#define CLOCK_PIN 12
#define DATA_PIN 13

#define TEMP 102.4

int raw1 = 0;
int raw2 = 0;
int raw3 = 0;

int segments = 0;
int seg_display = 1;

int temp = 0;
int light = 0;
int knock = 0;

const byte ledCharSet[10] = {
  B11000000, // 0
  B11111001, // 1
  B10100100, // 2
  B10110000, // 3
  B10011001, // 4
  B10010010, // 5
  B10000010, // 6
  B11111000, // 7
  B10000000, // 8
  B10010000  // 9
};

void setup() {
  pinMode(BUTTON1_PIN, INPUT);
  pinMode(BUTTON2_PIN, INPUT);
  pinMode(BUTTON3_PIN, INPUT);
  
  pinMode(KNOCK_SENSOR_PIN, INPUT);
  
  pinMode(LED1_PIN, OUTPUT);
  digitalWrite(LED1_PIN, LOW);
  pinMode(LED2_PIN, OUTPUT);
  digitalWrite(LED2_PIN, LOW);
  
  pinMode(BUZZER_PIN, OUTPUT);
  digitalWrite(BUZZER_PIN, LOW);
  
  pinMode(SLIDER1_LED_PIN, OUTPUT);
  digitalWrite(SLIDER1_LED_PIN, LOW);
  pinMode(SLIDER2_LED_PIN, OUTPUT);
  digitalWrite(SLIDER2_LED_PIN, LOW);
  pinMode(SLIDER3_LED_PIN, OUTPUT);
  digitalWrite(SLIDER3_LED_PIN, LOW);
  
  pinMode(LATCH_PIN, OUTPUT);
  digitalWrite(LATCH_PIN, LOW);
  pinMode(CLOCK_PIN, OUTPUT);
  digitalWrite(CLOCK_PIN, LOW);
  pinMode(DATA_PIN, OUTPUT);
  digitalWrite(DATA_PIN, LOW);
}

void loop() {
  raw1 = analogRead(SLIDER1_PIN);
  raw2 = analogRead(SLIDER2_PIN);
  raw3 = analogRead(SLIDER3_PIN);
  
  if (digitalRead(BUTTON1_PIN)==HIGH) {
    seg_display = 1;
  }
  if (digitalRead(BUTTON2_PIN)==HIGH) {
    seg_display = 2;
  }
  if (digitalRead(BUTTON3_PIN)==HIGH) {
    seg_display = 3;
  }
  
  if (seg_display == 1) {
    segments = raw1 / TEMP;
  }
  if (seg_display == 2) {
    segments = raw2 / TEMP;
  }
  if (seg_display == 3) {
    segments = raw3 / TEMP;
  }
  
  analogWrite(SLIDER1_LED_PIN, raw1);
  analogWrite(SLIDER2_LED_PIN, raw2);
  analogWrite(SLIDER3_LED_PIN, raw3);

  digitalWrite(LATCH_PIN,LOW);
  shiftOut(DATA_PIN,CLOCK_PIN,MSBFIRST,~(ledCharSet[segments]));
  digitalWrite(LATCH_PIN,HIGH);
  
  temp = analogRead(TEMP_SENSOR_PIN) / 8;
  analogWrite(LED1_PIN, temp);
  
  light = analogRead(LIGHT_SENSOR_PIN) / 8;
  analogWrite(LED2_PIN, light);
  
  knock = analogRead(KNOCK_SENSOR_PIN);
  if (knock < 50) {
    for (int x = 0; x < 50; x++) {
      digitalWrite(BUZZER_PIN, HIGH);
      delay(1);
      digitalWrite(BUZZER_PIN, LOW);
      delay(1);
    }
  }
}

